<?php
	//Include useful functions page, if it exists
	if(file_exists("backend/functions.php"))
	{
		include("backend/functions.php");
	}
?>
<?php
	//Get system name
	$sysname=system_name();
?>
<?php
	//Open session
	$altsesstore=alt_ses_store();
	if($altsesstore !== false)
	{
		session_save_path($altsesstore);
	}
	session_start();
?>
<?php
	//Administrative check function (on a separate page)
	if(file_exists("backend/securitycheck.php"))
	{
		include ("backend/securitycheck.php");
	}
	else
	{
		die("Failed to open file \"backend/securitycheck.php\" in read mode. It should now be microwaved.");
	}
?>
<?php
	//Custom error handler
	function eh($errno, $errstr, $errfile, $errline)
	{
		switch ($errno)
		{
			case E_USER_WARNING:
			echo "<b><u>WARNING:</u></b> " . $errstr . "<br><br>\n";
			break;

			case E_USER_NOTICE:
			echo "<b><u>NOTICE:</u></b> " . $errstr . "<br><br>\n";
			break;
			
			case E_WARNING:
			echo "<b><u>PHP WARNING:</u></b> " . $errstr . "<br><br>\n";
			break;

			case E_NOTICE:
			break;

			default:
			echo "Unhandled error.<br><br>\n";
			break;
    	}

    	/* Don't execute PHP internal error handler */
    	return true;
	}
	//Set error handler to the custom one
	$oeh=set_error_handler("eh");
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8">
    <meta name="generator" content="CoffeeCup HTML Editor (www.coffeecup.com)">
    <meta name="created" content="Wed, 17 Jun 2015 12:33:52 GMT">
    <meta name="description" content="Listening to a live stream? Got a song you have to hear? This is the place to request it!">
	<link rel="shortcut icon" href="backend/favicon.ico">
    <title><?php echo $sysname; ?>Music Request System-View Log</title>
	<script type="text/javascript" src="backend/jquery.js"></script>
	<script type="text/javascript" src="backend/tablesorter.js"></script>
	<link rel="stylesheet" href="backend/tsstyle/style.css" type="text/css" media="print, projection, screen" />
	<script type="text/javascript">
	$(function() {
		$("#reportstable").tablesorter();
	});
	</script>
    
    <style type="text/css">
    <!--
    body {
      color:#000000;
	  background-color:#FFFFFF;
      background-image:url('backend/background.gif');
      background-repeat:repeat;
    }
    a  { color:#FFFFFF; background-color:#0000FF; }
    a:visited { color:#FFFFFF; background-color:#800080; }
    a:hover { color:#000000; background-color:#00FF00; }
    a:active { color:#000000; background-color:#FF0000; }
	
	table,th,td { border: 1px solid #000000; }
    -->
    </style>
  </head>
<?php
	if(isset($_GET['removed']))
	{
		switch($_GET['removed'])
		{
			case "yes":
			echo ("Report removed from list.<br>\r\n");
			break;
			default:
			echo ("Report not removed from list.<br>\r\n");
			break;
		}
	}
	if(file_exists("backend/logging.txt") && file_get_contents("backend/logging.txt") == "yes")
	{
		$ip=$_SERVER['REMOTE_ADDR'];
		$date=date("g:i:s");
		$fh=fopen("log/" . date("Ymd") . ".txt",'a') or die("Failed to open file \"log/" . date("Ymd") . ".txt\" in append mode. It should now be microwaved.");
		fwrite($fh,$ip . " at " . $date . ": Visited logfile viewing page\r\n");
		if(securitycheck() === false)
		{
			//User is not administrator
			fclose($fh);
			die("You are not an administrator. <a href=\"login.php\">Sign in</a> or <a href=\"index.php\">Cancel</a>.");
		}
		if(isset($_GET['remove']))
		{
			//Sanitize!
			$rm=preg_replace("/[^0-9\-]/","",$_GET['remove']);
			if(file_exists("reports/" . $rm . ".txt"))
			{
				//Remove file
				$debug=unlink("reports/" . $rm . ".txt");
				if($debug === true)
				{
					//File removed
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Removed file " . $rm . "\r\n");
					$removed="yes";
				}
				else
				{
					//File not removed
					$date=date("g:i:s");
					fwrite($fh,$ip . " at " . $date . ": Failed to remove file " . $rm . "\r\n");
					$removed="no";
				}
			}
			else
			{
				//File doesn't exist
				$date=date("g:i:s");
				fwrite($fh,$ip . " at " . $date . ": Failed to remove file " . $rm . "\r\n");
				$removed="no";
			}
			fclose($fh);
			echo ("<script type=\"text/javascript\">window.location = \"viewreports.php?removed=$removed\"</script>");
		}
		fclose($fh);
	}
	else
	{
		if(securitycheck() === false)
		{
			//User is not administrator
			die("You are not an administrator. <a href=\"login.php\">Sign in</a> or <a href=\"index.php\">Cancel</a>.");
		}
		if(isset($_GET['remove']))
		{
			//Sanitize!
			$rm=preg_replace("/[^0-9\-]/","",$_GET['remove']);
			if(file_exists("reports/" . $rm . ".txt"))
			{
				//Remove file
				$debug=unlink("reports/" . $rm . ".txt");
				if($debug === true)
				{
					//File removed
					$removed="yes";
				}
				else
				{
					//File not removed
					$removed="no";
				}
			}
			else
			{
				//File doesn't exist
				$removed="no";
			}
			echo ("<script type=\"text/javascript\">window.location = \"viewreports.php?removed=$removed\"</script>");
		}
	}
?>
  <body>
  <h1 style="text-align:center; text-decoration:underline;"><?php echo $sysname; ?>MRS-View Reports</h1>
  <table id="reportstable" class="tablesorter">
  <thead>
  <tr>
  <th>Post ID</th>
  <th>Username</th>
  <th>Posted</th>
  <th>Request</th>
  <th>Reportee</th>
  <th>Reported</th>
  <th>Additional Comment</th>
  <th></th>
  </tr>
  </thead>
  <tbody>
  <?php
	$reports=glob("reports/*.txt");
	if(count($reports) > 0)
	{
		foreach($reports as $report)
		{
			$contents=explode("\r\n",base64_decode(file_get_contents($report)));
			echo ("<tr>\r\n<td>" . $contents[0] . "</td>\r\n<td>" . $contents[1] . "</td>\r\n<td>" . $contents[2] . "</td>\r\n<td>" . $contents[3] . "</td>\r\n<td>" . $contents[4] . "</td>\r\n<td>" . $contents[5] . "</td>\r\n<td>" . $contents[6] . "</td>\r\n<td><a href=\"viewreports.php?remove=" . substr($report,8,-4) . "\">Close</a></td>\r\n</tr>\r\n");
		}
	}
	else
	{
		echo ("<tr>\r\n<td colspan=\"8\">No reports at this time</td>\r\n</tr>\r\n");
	}
  ?>
  </tbody>
  </table>
  <p><a href="index.php">Go home</a></p>
  </body>
</html>